# Enum stable_mir::mir::TerminatorKind

source ·

    pub enum TerminatorKind {
        Goto {
            target: BasicBlockIdx,
        },
        SwitchInt {
            discr: Operand,
            targets: SwitchTargets,
        },
        Resume,
        Abort,
        Return,
        Unreachable,
        Drop {
            place: Place,
            target: BasicBlockIdx,
            unwind: UnwindAction,
        },
        Call {
            func: Operand,
            args: Vec<Operand>,
            destination: Place,
            target: Option<BasicBlockIdx>,
            unwind: UnwindAction,
        },
        Assert {
            cond: Operand,
            expected: bool,
            msg: AssertMessage,
            target: BasicBlockIdx,
            unwind: UnwindAction,
        },
        InlineAsm {
            template: String,
            operands: Vec<InlineAsmOperand>,
            options: String,
            line_spans: String,
            destination: Option<BasicBlockIdx>,
            unwind: UnwindAction,
        },
    }

## Variants§

§

### Goto

#### Fields

§`target: BasicBlockIdx`
§

### SwitchInt

#### Fields

§`discr: Operand`
§`targets: SwitchTargets`
§

### Resume

§

### Abort

§

### Return

§

### Unreachable

§

### Drop

#### Fields

§`place: Place`
§`target: BasicBlockIdx`
§`unwind: UnwindAction`
§

### Call

#### Fields

§`func: Operand`
§`args: Vec<Operand>`
§`destination: Place`
§`target: Option<BasicBlockIdx>`
§`unwind: UnwindAction`
§

### Assert

#### Fields

§`cond: Operand`
§`expected: bool`
§`msg: AssertMessage`
§`target: BasicBlockIdx`
§`unwind: UnwindAction`
§

### InlineAsm

#### Fields

§`template: String`
§`operands: Vec<InlineAsmOperand>`
§`options: String`
§`line_spans: String`
§`destination: Option<BasicBlockIdx>`
§`unwind: UnwindAction`

## Implementations§

source§

### impl TerminatorKind

source

#### pub fn successors(&self) -> Successors

source

#### pub fn unwind(&self) -> Option<&UnwindAction>

## Trait Implementations§

source§

### impl Clone for TerminatorKind

source§

#### fn clone(&self) -> TerminatorKind

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl Debug for TerminatorKind

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl PartialEq for TerminatorKind

source§

#### fn eq(&self, other: &TerminatorKind) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · source§

#### fn ne(&self, other: &Rhs) -> bool

This method tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
source§

### impl Eq for TerminatorKind

source§

### impl StructuralPartialEq for TerminatorKind

## Auto Trait Implementations§

§

### impl Freeze for TerminatorKind

§

### impl RefUnwindSafe for TerminatorKind

§

### impl Send for TerminatorKind

§

### impl Sync for TerminatorKind

§

### impl Unpin for TerminatorKind

§

### impl UnwindSafe for TerminatorKind

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 352 bytes

Size for each variant:

- `Goto`: 8 bytes
- `SwitchInt`: 248 bytes
- `Resume`: 0 bytes
- `Abort`: 0 bytes
- `Return`: 0 bytes
- `Unreachable`: 0 bytes
- `Drop`: 56 bytes
- `Call`: 304 bytes
- `Assert`: 352 bytes
- `InlineAsm`: 240 bytes